#include "nrf51.h"
#include "nrf_delay.h"
#include "SEGGER_RTT.h"

void elf_entry_point()
{
    __ASM volatile (
    ".syntax unified\n"
    ".globl  ELF_Entry_Point\n"
    ".type   ELF_Entry_Point, %function\n"
    "ELF_Entry_Point:\n"
    "ldr     r0,=__StackTop\n"			/* load stack pointer into R0 */
    "mov     sp,r0\n"					/* write stack pointer into sp register */
    "sub     sp,#4\n"					/* substract 4 (memory width) form sp, write back into sp  */
    "movs    r0,#0\n"						/* move zero into R0 */
    "mvns    r0,r0\n"						/* invert value in R0 */
    "str     r0,[sp,#0]\n"				/* store content of R0 (0xFFFFFFFF) onto stack */
    "add     sp,#4\n"
    ".syntax divided\n");

    SEGGER_RTT_Init();
    SEGGER_RTT_printf(0, "\n\n\n===================\n");
    SEGGER_RTT_printf(0,       "  ELF Entry Point  \n");
    SEGGER_RTT_printf(0,       "===================\n");
    SEGGER_RTT_printf(0,       "  The debugger startet execution at the ELF file entry point.\n");
    SEGGER_RTT_printf(0,       "  Performing NVIC_SystemReset() for correct initialization of the SoftDevice...\n\n\n");
    nrf_delay_ms(100);
    NVIC_SystemReset();
}
